SystemOrganization addCategory: #'CS598rej-HW5'!
SystemOrganization addCategory: #'CS598rej-HW5-Test'!

Object subclass: #ElectronicPart
	instanceVariableNames: 'name basePrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

!ElectronicPart class methodsFor: 'instance creation' stamp: 'm3r 6/26/2008 01:47'!
name: aString price: aNumber
	^ ElectronicPart new name: aString price: aNumber
! !

!ElectronicPart methodsFor: 'accessing' stamp: 'm3r 6/26/2008 01:46'!
basePrice
	^ basePrice
! !

!ElectronicPart methodsFor: 'accessing' stamp: 'm3r 6/26/2008 01:46'!
name
	^ name
! !

!ElectronicPart methodsFor: 'initialize-release' stamp: 'm3r 6/26/2008 01:46'!
name: aString price: aNumber
	name := aString.
	basePrice := aNumber.
! !

Object subclass: #Merchant
	instanceVariableNames: 'name premiumRate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

Merchant subclass: #Company
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

!Company methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 02:03'!
discountFrom: aSeller
	^ aSeller discountForCompany: self
! !

!Merchant class methodsFor: 'instance creation' stamp: 'm3r 6/26/2008 01:59'!
name: aString premiumRate: aNumber
	^ self new name: aString premiumRate: aNumber
! !

!Merchant methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 01:49'!
discountForCompany: aBuyer
	self subclassResponsibility.
! !

!Merchant methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 01:49'!
discountFrom: aSeller
	self subclassResponsibility.
! !

!Merchant methodsFor: 'accessing' stamp: 'm3r 6/26/2008 01:50'!
name
	^ name
! !

!Merchant methodsFor: 'initialize-release' stamp: 'm3r 6/26/2008 01:59'!
name: aString premiumRate: aNumber
	name := aString.
	premiumRate := aNumber.
! !

!Merchant methodsFor: 'accessing' stamp: 'm3r 6/26/2008 01:59'!
premiumRate
	^ premiumRate
! !

Merchant subclass: #Retailer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5'!

!Retailer methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 02:02'!
discountForCompany: aCompany
	^ aCompany premiumRate * 0.95
! !

!Retailer methodsFor: 'double dispatch' stamp: 'm3r 6/26/2008 02:10'!
discountFrom: aSeller
	"This method is an example of how NOT to write double dispatch code."
	"Reimplement this method properly."
	(aSeller class = Company) ifTrue: [^ aSeller premiumRate * 0.85].
	(aSeller class = Retailer) ifTrue: [^ aSeller premiumRate * 0.90]. 
! !

TestCase subclass: #DoubleDispatchTest
	instanceVariableNames: 'item company retailer person itemPrice corporatePremium retailPremium personalPremium'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS598rej-HW5-Test'!

!DoubleDispatchTest methodsFor: 'running' stamp: 'm3r 6/27/2008 08:30'!
setUp
	| individualClass |
	itemPrice := 100.
	corporatePremium := 0.5.
	retailPremium := 0.6.
	personalPremium := 0.75.
	item := ElectronicPart name: 'DVD' price: itemPrice.
	company := Company name: 'Samsung' premiumRate: corporatePremium.
	retailer := Retailer name: 'Best Buy' premiumRate: retailPremium.
	(individualClass := Smalltalk classNamed: #Individual) ifNotNil:
		[person :=  individualClass name: 'Steve Jobs' premiumRate: personalPremium].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:08'!
testCompanyBuysFromCompany
	| cost |
	cost := item basePrice * (company discountFrom: company).
	self should: [cost closeTo: (itemPrice * corporatePremium * 0.80)].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:10'!
testCompanyBuysFromRetailer
	| cost |
	cost := item basePrice * (company discountFrom: retailer).
	self should: [cost closeTo: (itemPrice * corporatePremium * 0.95)].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 03:22'!
testDoubleDispatchIsImplemented
	Merchant withAllSubclassesDo:
		[: class | #(discountForCompany: discountForRetailer: discountFrom:) do:
			[: selector | self should: [class includesSelector: selector]]].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 03:21'!
testDoubleDispatchIsImplementedForIndividual
	Merchant withAllSubclassesDo:
		[: class | self should: [class includesSelector: #discountForIndividual:]].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:16'!
testIndividualBuys
	| cost |
	cost := item basePrice * (person discountFrom: person).
	self should: [cost closeTo: (itemPrice * personalPremium * 1.0)].
	cost := item basePrice * (person discountFrom: company).
	self should: [cost closeTo: (itemPrice * personalPremium * 0.95)].
	cost := item basePrice * (person discountFrom: retailer).
	self should: [cost closeTo: (itemPrice * personalPremium * 0.85)].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/26/2008 03:33'!
testIndividualSells
	self shouldnt: [person discountFrom: person] raise: Error.
	self should: [company discountFrom: person] raise: Error.
	self should: [retailer discountFrom: person] raise: Error.
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:14'!
testRetailerBuysFromCompany
	| cost |
	cost := item basePrice * (retailer discountFrom: company).
	self should: [cost closeTo: (itemPrice * retailPremium * 0.85)].
! !

!DoubleDispatchTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 01:14'!
testRetailerBuysFromRetailer
	| cost |
	cost := item basePrice * (retailer discountFrom: retailer).
	self should: [cost closeTo: (itemPrice * retailPremium * 0.90)].
! !
